#include <ctype.h>
#include <stdio.h>

#define NUMERIC 0
#define ASCII   1

main(argc,argv)

char *argv[];
int argc;

{
int argindex;                  // current arg from command linh
int state = ASCII;             // current state while reading args
char lastchar='\0';            // lastchar seen in input
char nonprint;                 // for specified non-printable characters

FILE *output;                  // output device (binary)
char *dptr;                    // pointer to data in input buffer

if (argc == 1)
   {
   do_help();     
   exit(0);
   }
if (argc <= 2)
   {
   fputs("SENDTO:  Invalid number of arguments.\n",stderr);
   exit(1);
   }
   
output = fopen(argv[1],"ab");
if (!output)
    {
    perror("Unable to open output device");
    exit(1);
    }
    
// begin scan of the argument string.  

for (argindex = 2;argindex < argc; argindex++)
   {
   dptr = argv[argindex];

   while (*dptr != '\0')
      {
      switch (*dptr)
         {
         case '\\':  if (state==ASCII)       // first encounter of "\"
                        {
                        state = NUMERIC;
                        lastchar = *dptr;
                        nonprint = '\0';
                        dptr++;
                        break;
                        }
                     if (state==NUMERIC && lastchar=='\\')   // handle "\\"
                        {
                        state=ASCII;
                        lastchar = *dptr;
                        if (!fputc(*dptr,output)) perror("Write error");
                        dptr++;
                        break;
                        }
                     
                        
            default: if (state==ASCII)
                        {
                        if (!fputc(*dptr,output)) perror("Write error");
                        lastchar = *dptr;
                        dptr++;
                        break;
                        }
                     if (state==NUMERIC && !isdigit(*dptr))   // end of digit 
                        {                                     // string
                        state=ASCII;
                        if (!fputc(nonprint,output)) perror("Write error");
                        lastchar = *dptr;
                        break;
                        }
                        
                     nonprint *= 10;                          // a digit
                     nonprint += *dptr-48;
                     lastchar = *dptr;
                     dptr++;
                     break;
                     
             }  // end of switch
          }     // end of while
      
      if (state==NUMERIC)                     // we're holding something 
         {
         if (!fputc(nonprint,output)) perror("Write error");
         }
         
      state = ASCII;
      }   // for 
   fclose(output);
   }

do_help()
   {
   fputs("SENDTO: Version 2; Copyright 1989, 1990 Steven D. Stern\n",stderr);
   fputs("usage:   SENDTO <device> <data>\n",stderr);
   fputs("         where <device> is a file name or device (e.g., 'PRN')\n",stderr);
   fputs("           and <data> is a list of printable characters or characters\n",stderr);
   fputs("           expressed as decimal digits (indicated with a leading '\\').\n",stderr);
   fputs("example: SENDTO prn \\027E \n",stderr);
   fputs("         This sends the string <escape>E to the printer\n\n",stderr);
   }
